SystemOrganization addCategory: #'Twitter-Bootstrap-Examples-Magritte'!

WAComponent subclass: #TWBSExampleInformsConfirms
	instanceVariableNames: 'informMessage confirmMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSExampleInformsConfirms class methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 10:31'!
label
	^ [ :html | html text: 'Bootstrap versions of Seaside''s '; code: 'WAComponent>>#inform'; text: ', '; code: 'WAComponent>>#confirm' ]! !

!TWBSExampleInformsConfirms methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 08:10'!
confirmMessage
	^ confirmMessage ifNil: [ 'Does this colour suit me?' ]! !

!TWBSExampleInformsConfirms methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 08:10'!
confirmMessage: anObject
	confirmMessage := anObject! !

!TWBSExampleInformsConfirms methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 08:05'!
confirms
	^ Array with: #twbsConfirmInfo: -> 'btn-info' with: #twbsConfirmSuccess: -> 'btn-success'  with: #twbsConfirmError: -> 'btn-danger'
! !

!TWBSExampleInformsConfirms methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 08:09'!
informMessage
	^ informMessage ifNil: [ informMessage := 'A really important message' ]! !

!TWBSExampleInformsConfirms methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 08:06'!
informMessage: anObject
	informMessage := anObject! !

!TWBSExampleInformsConfirms methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 08:14'!
informs
	^ Array with: #twbsInform: -> 'btn-info' with: #twbsInformSuccess: -> 'btn-success'  with: #twbsInformError: -> 'btn-danger'
! !

!TWBSExampleInformsConfirms methodsFor: 'rendering' stamp: 'NickAger 3/23/2012 08:13'!
renderContentOn: html
	html form: [
		html label: [
			html text: 'Inform Message: '.
		html textInput 
			on: #informMessage of: self ].
		
		html div: [
			self informs do: [ :each |
				html button
					class: 'btn';
					class: each value;
					callback: [ self perform: each key with: [ :r | r strong: 'Message: '; text: self informMessage ] ];
					with: each key ] 
				separatedBy: [ html space ] ].
			
		html break.
		html label: [
			html text: 'Confirm Message: '.
		html textInput 
			on: #confirmMessage of: self ].
			
		html div: [
			self confirms do: [ :each |
				html button
					class: 'btn';
					class: each value;
					callback: [ self perform: each key with: [ :r | r strong: 'Message: '; text: self confirmMessage ] ];
					with: each key ] 
				separatedBy: [ html space ] ].

		html div 
			class: 'form-actions'; 
			with: [
				html button
					class: 'btn';
					callback: [ self answer ];
					with: 'Return' ] ] ! !

WAComponent subclass: #TWBSExampleMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSExampleMenu methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 07:43'!
examples
	^ Array with: TWBSMagritteExampleFormTask with: TWBSMagritteReportExampleTask with: TWBSExampleInformsConfirms! !

!TWBSExampleMenu methodsFor: 'rendering' stamp: 'NickAger 3/23/2012 08:21'!
renderContentOn: html
	html div
		class: 'page-header';
		with: [ 
			html heading level3; with:  'Twitter Bootstrap Seaside examples' ].
		
	html table
		class: 'table table-striped table-bordered';
		with: [
			html tableHead: [
				html tableRow: [
					html tableHeading: 'Example' ] ].
			html tableBody: [
				self examples do: [ :each | 
					html tableRow: [
						html tableData: [ 
							html anchor 
								callback: [ self show: each new ];
								with: each label  ] ] ] ] ]! !

WAComponent subclass: #TWBSExamples
	instanceVariableNames: 'menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSExamples class methodsFor: 'initialization' stamp: 'NickAger 3/23/2012 07:20'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'twitter-bootstrap-examples'.
	application preferenceAt: #scriptGeneratorClass put: JQScriptGenerator	! !

!TWBSExamples methodsFor: 'hooks' stamp: 'NickAger 3/23/2012 07:20'!
children
	^ Array with: self menu! !

!TWBSExamples methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 07:19'!
menu
	^ menu ifNil: [ menu := TWBSExampleMenu new ]! !

!TWBSExamples methodsFor: 'rendering' stamp: 'NickAger 3/23/2012 07:20'!
renderContentOn: html
	html twbsContainer: [
		html twbsRow: [
			html twbsSpan: 12 with: [
				html heading level1; with: [
					html text: 'Twitter Bootstrap '; small: 'Seaside and Magritte rendering examples' ] ] ].
		
		html twbsRow: [
			html twbsSpan: 7 with: self menu ].
		
		html twbsRow: [
			html twbsSpan: 7 with: [
				html text: 'For more information see the '.
				html anchor url: 'http://twitter.github.com/bootstrap/'; with: 'Twitter Bootstrap documentation' ] ] ]
! !

!TWBSExamples methodsFor: 'updating' stamp: 'NickAger 3/23/2012 08:17'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	JQDevelopmentLibrary default updateRoot: anHtmlRoot.
	TWBSDevelopmentLibrary default updateRoot: anHtmlRoot.
	
	anHtmlRoot title: 'Seaside Twitter Bootstrap examples'! !

WAComponent subclass: #TWBSMagritteReportWrapper
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteReportWrapper methodsFor: 'initialize-release' stamp: 'JanVanDeSandt 3/22/2012 18:01'!
close

	self answer: nil! !

!TWBSMagritteReportWrapper methodsFor: 'rendering' stamp: 'NickAger 3/23/2012 08:16'!
renderContentOn: html

	html render: self report.
	
	html div 
		class: 'form-actions'; 
		with: [
			html anchor
				class: 'btn' ;
				callback: [ self close ] ;
				with: 'Close' ]! !

!TWBSMagritteReportWrapper methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 18:01'!
report
	^ report! !

!TWBSMagritteReportWrapper methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 18:01'!
report: anObject
	report := anObject! !

WATask subclass: #TWBSMagritteExampleFormTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteExampleFormTask class methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 07:29'!
label
	^ 'Magritte Form example'! !

!TWBSMagritteExampleFormTask methodsFor: 'private' stamp: 'NickAger 3/23/2012 06:52'!
createFormBasedOn: formChooser
	| theForm |
	theForm := TWBSMagritteExampleFormDescription new asComponent.
	
	formChooser isValidationMessageStyleTop ifTrue: [
		theForm addDecoration: TWBSMagritteValidationDecoration new ].
	
	theForm
		addDecoration: 
			(TWBSMagritteFormDecoration newWithDefaultButtons 
				formCss: formChooser layoutStyle;
				legend: formChooser optionsSelectedString;
				yourself);
		yourself.
	
	theForm magritteDescription twbsInlineValidationMessages: formChooser isValidationMessageStyleInline.
	formChooser isLayoutStyleFormInline ifTrue: [
		theForm magritteDescription twbsFormInline: true.
		"inline styles look better without comments"
		theForm magritteDescription do: [ :aDescription |
			aDescription comment: nil ] ].
	
	^ theForm! !

!TWBSMagritteExampleFormTask methodsFor: 'private' stamp: 'NickAger 3/23/2012 06:52'!
formChooser
	^ (TWBSMagritteExampleFormChooser new asComponent)
		addDecoration: (TWBSMagritteFormDecoration buttons: (Array with: #save -> 'Create a new form'));
		yourself! !

!TWBSMagritteExampleFormTask methodsFor: 'running' stamp: 'NickAger 3/23/2012 07:34'!
go
	| chosenForm formChooser chosenFormAnswer |
	formChooser := self call: self formChooser.
	chosenForm := (self createFormBasedOn: formChooser).
	
	chosenFormAnswer := self call: chosenForm.
	chosenFormAnswer notNil
		ifTrue: [ self twbsInformSuccess: [ :r | r strong: 'Well done'; text: ' you have managed to survive our arbitary validation.' ] ]
		ifFalse: [ self twbsInformError: [ :r | r strong: 'Cancelled'; text: ' Oh well you can always try again to see if you can work-through our arbitary validation.' ] ]! !

WATask subclass: #TWBSMagritteReportExampleTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteReportExampleTask class methodsFor: 'accessing' stamp: 'NickAger 3/23/2012 07:29'!
label
	^ 'Magritte Report example'! !

!TWBSMagritteReportExampleTask methodsFor: 'private' stamp: 'NickAger 3/23/2012 06:52'!
createReportBasedOn: reportChooser

	| theReport |
	
	theReport := TWBSMagritteReport rows: self demoRows description: TWBSMagritteExampleFormDescription new magritteDescription. 
	theReport
		showBatchFirstLast: reportChooser showBatchFirstLast ;
		showBordered: reportChooser bordered ;
		showStriped: reportChooser striped ;
		showCondensed: reportChooser condensed.
	
	^ TWBSMagritteReportWrapper new
		report: theReport ;
		yourself! !

!TWBSMagritteReportExampleTask methodsFor: 'private' stamp: 'NickAger 3/23/2012 06:52'!
demoRows

	| rows |
	
	rows := OrderedCollection new.
	Collection withAllSubclasses doWithIndex: [ :each :index |
		rows add: (TWBSMagritteExampleFormDescription new
			name: each name;
			number: index ;
			bePositive: index odd ;
			yourself ) ].
	^ rows

! !

!TWBSMagritteReportExampleTask methodsFor: 'running' stamp: 'NickAger 3/23/2012 07:36'!
go
	| chosenReport reportChooser |
	reportChooser := self call: self reportChooser.
	chosenReport := (self createReportBasedOn: reportChooser).
	
	self call: chosenReport.
	self twbsInformSuccess: [ :r | r strong: 'Thanks for looking at my report!!' ]! !

!TWBSMagritteReportExampleTask methodsFor: 'private' stamp: 'NickAger 3/23/2012 06:22'!
reportChooser
	^ (TWBSMagritteReportChooser new asComponent)
		addDecoration: ((TWBSMagritteFormDecoration buttons: (Array with: #save -> 'Create a new report'))
			legend: 'Select a report style';
			formCss: 'form-horizontal' ;
			yourself );
		yourself! !

GRObject subclass: #TWBSMagritteExampleFormChooser
	instanceVariableNames: 'layoutStyle validationMessageStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteExampleFormChooser methodsFor: 'magritte descriptions' stamp: 'NickAger 3/19/2012 17:05'!
descriptionContainer
	<magritteContainer>
	^ super descriptionContainer
		componentRenderer: TWBSMagritteFormRenderer;
		yourself! !

!TWBSMagritteExampleFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:03'!
isLayoutStyleFormInline
	^ self layoutStyle = 'form-inline'! !

!TWBSMagritteExampleFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:47'!
isValidationMessageStyleBoth
	^ self validationMessageStyle = 'Inline and top validation messages'! !

!TWBSMagritteExampleFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:47'!
isValidationMessageStyleInline
	^ self isValidationMessageStyleTop not or: [ self isValidationMessageStyleBoth ]! !

!TWBSMagritteExampleFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:47'!
isValidationMessageStyleTop
	^ self validationMessageStyle = 'top validation messages' or: [ self isValidationMessageStyleBoth ]! !

!TWBSMagritteExampleFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 17:28'!
layoutStyle
	^ layoutStyle ifNil: [ layoutStyle := self layoutStyles first ]! !

!TWBSMagritteExampleFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:34'!
layoutStyle: anObject
	layoutStyle := anObject! !

!TWBSMagritteExampleFormChooser methodsFor: 'magritte descriptions' stamp: 'NickAger 3/21/2012 20:50'!
layoutStyleDescription
	<magritteDescription>
	^ MASingleOptionDescription new 
		label: 'Layout styles';
		accessor: #layoutStyle;
		options: self layoutStyles;
		comment: 'choose a layout style';
		componentClass: TWBSMagritteRadioGroupComponent;
		beRequired;
		yourself! !

!TWBSMagritteExampleFormChooser methodsFor: 'options' stamp: 'NickAger 3/19/2012 16:31'!
layoutStyles
	^ Array with: 'form-vertical' with: 'form-inline' with: 'form-search' with: 'form-horizontal'! !

!TWBSMagritteExampleFormChooser methodsFor: 'printing' stamp: 'NickAger 3/21/2012 18:09'!
optionsSelectedString
	^ layoutStyle, ', ', validationMessageStyle! !

!TWBSMagritteExampleFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:28'!
validationMessageStyle
	^ validationMessageStyle ifNil: [ validationMessageStyle := self validationMessageStyles first ]! !

!TWBSMagritteExampleFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:28'!
validationMessageStyle: anObject
	validationMessageStyle := anObject! !

!TWBSMagritteExampleFormChooser methodsFor: 'magritte descriptions' stamp: 'NickAger 3/20/2012 18:12'!
validationMessageStyleDescription
	<magritteDescription>
	^ MASingleOptionDescription new 
		label: 'Error message styles';
		accessor: #validationMessageStyle;
		options: self validationMessageStyles;
		comment: 'choose an error message style';
		componentClass: MASelectListRowsComponent;
		beRequired;
		yourself! !

!TWBSMagritteExampleFormChooser methodsFor: 'options' stamp: 'NickAger 3/20/2012 13:46'!
validationMessageStyles
	^ Array with: 'inline validation messages' with: 'top validation messages' with: 'Inline and top validation messages'! !

GRObject subclass: #TWBSMagritteExampleFormDescription
	instanceVariableNames: 'name number bePositive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteExampleFormDescription methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:22'!
bePositive
	^ bePositive ifNil: [ bePositive := true ]! !

!TWBSMagritteExampleFormDescription methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:21'!
bePositive: anObject
	bePositive := anObject! !

!TWBSMagritteExampleFormDescription methodsFor: 'magritte descriptions' stamp: 'NickAger 3/22/2012 12:36'!
bePositiveDescription
	<magritteDescription>
	^ MABooleanDescription new
		checkboxLabel: 'Be positive';
		accessor: #bePositive;
		componentClass: TWBSMagritteCheckboxComponent;
		priority: 600;
		yourself! !

!TWBSMagritteExampleFormDescription methodsFor: 'magritte descriptions' stamp: 'NickAger 3/19/2012 16:48'!
descriptionContainer
	<magritteContainer>
	^ super descriptionContainer
		componentRenderer: TWBSMagritteFormRenderer;
		yourself! !

!TWBSMagritteExampleFormDescription methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:48'!
name
	^ name
! !

!TWBSMagritteExampleFormDescription methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:48'!
name: anObject
	name := anObject! !

!TWBSMagritteExampleFormDescription methodsFor: 'magritte descriptions' stamp: 'NickAger 3/21/2012 20:51'!
nameDescription
	<magritteDescription>
	^ MAStringDescription new
		priority: 10;
		label: 'Name';
		accessor: #name;
		beRequired;
		requiredErrorMessage: 'We cannot proceed without a name.';
		comment: 'Please enter your name';
		componentClass: TWBSMagritteTextInputComponent; "is required for placeholder text below"
		placeholder: 'your name';
		yourself! !

!TWBSMagritteExampleFormDescription methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:56'!
number
	^ number! !

!TWBSMagritteExampleFormDescription methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:56'!
number: anObject
	number := anObject! !

!TWBSMagritteExampleFormDescription methodsFor: 'magritte descriptions' stamp: 'NickAger 3/20/2012 13:52'!
numberDescription
	<magritteDescription>
	^ MASingleOptionDescription new
		priority: 30;
		label: 'Numbers';
		accessor: #number;
		options: (0 to: 10);
		comment: 'select your favourite number';
		addCondition: [ :v | v ~= 0 ] labelled: 'sorry we are not permitting zero to be favourite';
		addCondition: [ :v | v ~= 1 ] labelled: 'sorry we are not permitting one to be favourite';
		beRequired;
		yourself! !

GRObject subclass: #TWBSMagritteReportChooser
	instanceVariableNames: 'bordered stiped condensed showBatchFirstLast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteReportChooser methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:08'!
bordered
	^ bordered! !

!TWBSMagritteReportChooser methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:08'!
bordered: anObject
	bordered := anObject! !

!TWBSMagritteReportChooser methodsFor: 'magrittes-descriptions' stamp: 'JanVanDeSandt 3/22/2012 17:55'!
borderedDescription
	<magritteDescription>
	^ MABooleanDescription new 
		label: 'Bordered';
		group: 'Bootstrap options' ;
		accessor: #bordered;
		comment: 'Rounds corners and adds outer border';
		default: false;
		componentClass: TWBSMagritteCheckboxComponent ;
		yourself! !

!TWBSMagritteReportChooser methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:08'!
condensed
	^ condensed! !

!TWBSMagritteReportChooser methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:08'!
condensed: anObject
	condensed := anObject! !

!TWBSMagritteReportChooser methodsFor: 'magrittes-descriptions' stamp: 'JanVanDeSandt 3/22/2012 17:55'!
condensedDescription
	<magritteDescription>
	^ MABooleanDescription new 
		label: 'Condensed';
		group: 'Bootstrap options' ;
		accessor: #condensed;
		comment: 'Cuts vertical padding in half';
		default: false;
		componentClass: TWBSMagritteCheckboxComponent ;
		yourself! !

!TWBSMagritteReportChooser methodsFor: 'magrittes-descriptions' stamp: 'JanVanDeSandt 3/22/2012 16:08'!
descriptionContainer
	<magritteContainer>
	^ super descriptionContainer
		componentRenderer: TWBSMagritteFormRenderer;
		yourself! !

!TWBSMagritteReportChooser methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 17:34'!
showBatchFirstLast
	^ showBatchFirstLast! !

!TWBSMagritteReportChooser methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 17:34'!
showBatchFirstLast: anObject
	showBatchFirstLast := anObject! !

!TWBSMagritteReportChooser methodsFor: 'magrittes-descriptions' stamp: 'JanVanDeSandt 3/22/2012 17:35'!
showBatchFirstLastDescription
	<magritteDescription>
	^ MABooleanDescription new 
		label: 'Show first/last';
		accessor: #showBatchFirstLast;
		default: false;
		componentClass: TWBSMagritteCheckboxComponent ;
		yourself! !

!TWBSMagritteReportChooser methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:12'!
striped
	^ stiped! !

!TWBSMagritteReportChooser methodsFor: 'accessing' stamp: 'JanVanDeSandt 3/22/2012 16:12'!
striped: anObject
	stiped := anObject! !

!TWBSMagritteReportChooser methodsFor: 'magrittes-descriptions' stamp: 'JanVanDeSandt 3/22/2012 17:25'!
stripedDescription
	<magritteDescription>
	^ MABooleanDescription new 
		label: 'Striped';
		accessor: #striped;
		comment: 'Adds light gray background color to odd rows';
		default: false;
		componentClass: TWBSMagritteCheckboxComponent ;
		yourself! !
TWBSExamples initialize!
